<?php

namespace eindwerk\Service;

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

class MailerService
{
    /**
     * Mailer constructor.
     *
     * @param bool|null $exceptions
     */
    public function __construct($exceptions)
    {
    }

    /**
     * Send registration email.
     *
     * @param string $email
     * @param string $name
     * @param string $token
     */
    public function sendRegisterMail(string $email, string $name, string $token)
    {
        $mail = new PHPMailer();

        $mail->isSMTP();
        $mail->Host       = 'smtp.gmail.com';
        $mail->SMTPAuth   = true;
        $mail->SMTPSecure = "tls";
        $mail->Port       = "587";

        $mail->Username   = 'gamer.iradotadez@gmail.com';
        $mail->Password   = $_ENV['SMTP_PASSWORD'];

        $mail->Subject = 'Welcome to Workspace!';

        $mail->setFrom('gamer.iradotadez@gmail.com');

        $url = explode(',', $_ENV['FRONTEND_URL'] ?: 'http://localhost:3000')[0];
        $body = '<a href="' . $url . '/validate?token=' . $token . '">Click here to validate your email address</a>';

        $mail->addAddress($email);

        $textBody = 'Validate your email address: ' . $url . '/validate?token=' . $token;
        try {

            $mail->msgHTML($body);
            $mail->AltBody = $textBody;
            if ($mail->send()) {
                echo "email send";
            }else{
                echo "lol";
            }
            $mail->smtpClose();
        } catch (Exception $e) {
            // PHPMailer error
            return $e->errorMessage();
        } catch (\Exception $e) {
            // Other error
            return $e->getMessage();
        }
    }

    public function passwordReset(string $email, string $name)
    {
        $mail = new PHPMailer();

        $mail->isSMTP();
        $mail->Host       = 'smtp.gmail.com';
        $mail->SMTPAuth   = true;
        $mail->SMTPSecure = "tls";
        $mail->Port       = "587";

        $mail->Username   = 'gamer.iradotadez@gmail.com';
        $mail->Password   = $_ENV['SMTP_PASSWORD'];

        $mail->Subject = 'Welcome to Workspace!';

        $mail->setFrom('gamer.iradotadez@gmail.com');

        $url = explode(',', $_ENV['FRONTEND_URL'] ?: 'http://localhost:3000')[0];
        $body = '<a href="' . $url . '/reset?token=' . $name . '">Click here to reset your password</a>';

        $mail->addAddress($email);

        $textBody = 'Validate your email address: ' . $url . '/reset?token=' . $name;
        try {

            $mail->msgHTML($body);
            $mail->AltBody = $textBody;
            if ($mail->send()) {
                echo "email send";
            }else{
                echo "lol";
            }
            $mail->smtpClose();
        } catch (Exception $e) {
            // PHPMailer error
            return $e->errorMessage();
        } catch (\Exception $e) {
            // Other error
            return $e->getMessage();
        }
    }
}
