<?php

namespace eindwerk\Entity;

use Psr\Container\ContainerInterface;

class State
{
    protected $container;
    protected $id;
    protected $name;

    public function __construct(ContainerInterface $container, int $id, string $name)
    {
        $this->container = $container;
        $this->$id = $id;
        $this->$name = $name;
    }
    
    public function init_states($value):array
    {
        $db = $this->container->get('db');
        $query = $db->prepare('
        SELECT state.id, state.name
        FROM state
        '); // 1 vervangen door id van geklikte project
        // $query->bindValue(':test', $value.id);
        $res = $query->execute();
        $data = [];
        while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            array_push($data, $row);
        }
        return $data;
    }
}
