<?php

namespace eindwerk\Entity;

use Psr\Container\ContainerInterface;

class Team
{
    protected $container;

    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    public function getAllTeams(): array
    {
        $db = $this->container->get('db');
        $query = $db->prepare('
        SELECT T.id, T.name, t.description
        FROM team T
        ORDER BY name asc
        ');

        $res = $query->execute();
        $data = [];
        while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            array_push($data, $row);
        }
        return $data;
    }
}
